#
#  $Id$
#
#  (C) Copyright 2003 Kai Sterker <kaisterker@linuxgames.com>
#  Part of the Adonthell Project http://adonthell.linuxgames.com
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License.
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY.
#
#  See the COPYING file for more details
#

import random
import damage

class physical (damage.damage):
    """Damage object representing physical damage."""

    def __init__ (self, d_dmg):
        """Create new physical damage object.

        d_dmg: a tuple representing the damage range."""
        damage.damage.__init__ (self, hash ("physical"), damage.damage.PHYSICAL, d_dmg)
    
    def to_string (self):
        """Textual representation of the damage object."""
        return "(physical %i-%i)" % (self.Damage[0], self.Damage[1])

    def apply_effect (self, attacker, defender):
        """Apply physical damage to target.
        
        attacker: the character performing the attack.
        defender: the character being attacked.
        return: 1 if defender has been hit, 0 otherwise."""
        to_hit = attacker.MeleeAttack + 50 - defender.Parry
        
        if to_hit > random.randrange (0, 101):
            damage = random.randrange (self.Damage[0], self.Damage[1]+1) - \
                defender.PhysicalResistance
            if damage > 0:
                defender.Health -= damage
                return 1
        else: return 0
